import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsSourcefile {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  PublisherId!: bigint;
  SourceId!: bigint;
  Name?: string;
  DocType?: string;
  SourceType!: number;
  SubType!: number;
  Status!: number;
  Url?: string;
  ViewNum!: number;
  DownNum!: number;
  QuestionNum!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsSourcefileSchema = defineEntity({
  class: ScsSourcefile,
  comment: '资源文件',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    PublisherId: p.bigint().name('PublisherId').comment('上传用户id'),
    SourceId: p.bigint().name('SourceId').comment('文件包id'),
    Name: p.string().name('Name').nullable().comment('文件名称').index('idx_SCS_SourceFile_01'),
    DocType: p.string().name('DocType').nullable().comment('文件类型()'),
    SourceType: p.integer().name('SourceType').comment('资源类型(试卷 课件 作业)'),
    SubType: p.integer().name('SubType').comment('按不同的SourceType类型对应'),
    Status: p.integer().name('Status').comment('状态'),
    Url: p.string().name('Url').length(1000).nullable().comment('资源地址'),
    ViewNum: p.integer().name('ViewNum').comment('浏览量'),
    DownNum: p.integer().name('DownNum').comment('下载量'),
    QuestionNum: p.integer().name('QuestionNum').comment('题量'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
